// Adds the link passed to it to the text in the content area
function p2_addlink(url) {
	
	// If TinyMCE is enabled, use this function first. The rest of the code fails with TinyMCE enabled
	tinyMCE.execCommand("mceInsertLink", false, url);
	
	var myField = document.getElementById('content');
	
	// IE support
	if (document.selection) {
		
		myField.focus();
		sel = document.selection.createRange();
		if (sel.text.length > 0) {
			sel.text = '<a href="' + url + '">' + sel.text + '</a>';
		} else if (sel.text.length == 0) {
			sel.text = url;
		}
		myField.focus();
		
	}
	// Mozilla and Netscape support
	else if (myField.selectionStart) {
		
		var startPos = myField.selectionStart;
		var endPos = myField.selectionEnd;
		var scrollTop = myField.scrollTop;
	
		// If there is text selected, wrap it with the link. Otherwise, insert the link
		if (startPos != endPos) {
			myField.value = myField.value.substring(0, startPos)
							+ '<a href="' + url + '">'
							+ myField.value.substring(startPos, endPos)
							+ '</a>'
							+ myField.value.substring(endPos, myField.value.length);
			var stringlength = endPos - startPos;
			var urllength = url.length + 15 + stringlength;
			myField.focus();
			myField.selectionStart = startPos + urllength;
			myField.selectionEnd = startPos + urllength;
		} else if (startPos == endPos) {
			myField.value = myField.value.substring(0, startPos)
							+ url
							+ myField.value.substring(endPos, myField.value.length);
			myField.focus();
		}
	
		myField.scrollTop = scrollTop;
		
	}
	
}

// Reveals or hides the source of links within the Link Assist widget
function p2_url_source(action) {
	
	action = parseInt(action);
	
	if (action == 1) {
		jQuery("#p2-links_header").hide();
		jQuery("#p2-source-option").fadeIn('normal');
	} else if (action == 2) {
		jQuery("#p2-source-option").hide();
		jQuery("#p2-links_header").fadeIn('normal');
		var feedlink = jQuery('#publish2-feedlink').val();
		//@todo: include something here to clean the URL
		p2_listlinks(feedlink);
	} else if (action == 3) {
		jQuery("#p2-source-option").hide();
		jQuery("#p2-links_header").fadeIn('normal');
	}
	
}

// Take a Publish2 tag and present it in a format that's usable in a URL
function p2_cleantag(thetag) {
	
	// Clean up the adhoc rating system that some use
	if (thetag == '*') {
		thetag = '-9';
	} else if (thetag == '**') {
		thetag = '-4';
	} else if (thetag == '***') {
		thetag = '-3';
	} else if (thetag == '****') {
		thetag = '-2';
	} else if (thetag == '*****') {
		thetag = '-5';
	}
	
	// All sorts of crazy characters that need to be filtered out
	thetag = thetag.replace(/\s+/g, "-");
	thetag = thetag.replace(/&/g, '-');
	thetag = thetag.replace(/---/g, '-');
	thetag = thetag.replace(/\./g, '');
	thetag = thetag.replace(/#/g, '-');
	thetag = thetag.replace(/\'/g, '-');
	
	return thetag;
		
}

// Check the URL to make sure there's a "http://" and trailing slash
function p2_cleanurl(feedlink) {
	
	var checkhttp = feedlink.indexOf('http://');
	if (checkhttp == -1) {
		feedlink = 'http://' + feedlink;
	}
	var feedlink_length = feedlink.length;
	var last_char = feedlink.charAt(feedlink_length - 1);
	if (last_char != '/') {
		feedlink = feedlink + '/';
	}
	
	return feedlink;
	
}

function p2_linksnav(option) {
	var feedlink = jQuery('#publish2-feedlink').val();
	var thetag = jQuery('#p2-filter_tag').val();
	var links_low = jQuery('#p2-temp_links_low').html();
	var links_low = parseInt(links_low);
	
	if (option == true) {
		links_low = links_low + 3;
		p2_listlinks(feedlink, thetag, links_low);		
	} else if (option == 'reset') {
		p2_listlinks(feedlink);
	} else if (option == 'filter') {
		var thetag = jQuery('#p2-filter_tag').val();
		p2_listlinks(feedlink, thetag, null);
	} else if (option == 4) {
		feedlink = jQuery('#publish2-feedlink_new').val();
		p2_listlinks(feedlink);
		jQuery('#publish2-feedlink').val(feedlink);
	} else {
		links_low = links_low - 3;
		p2_listlinks(feedlink, thetag, links_low);
	}
	
}

function p2_update_links(page_num) {
	
	var total_links = jQuery('#p2-temp_total_links').html();
	
	if (page_num < 1) {
		page_num = 1;
	}
	links_low = (page_num - 1) * 3;
	var links_high = links_low + 2;
	
	// Cycles through and shows or hides each link based on the lowest number that should be displayed
	for (i = 0; i < total_links; i++) {
		var link_num = i + 1;
		var link_div = '#p2-link_num-' + link_num;
		if (i >= links_low && i <= links_high) {
			jQuery(link_div).show();
		} else {
			jQuery(link_div).hide();
		}
	}
	
	// Create pagination based on the links you just displayed
	p2_create_pagination(links_low);
	
}

// Builds the side tabs to go backwards and fowards through the user's links
function p2_create_pagination(links_low, total_links) {
	
	if (total_links == null) {
		total_links = jQuery('#p2-temp_total_links').html();
	}

	// Generate the "previous" button and action. Won't display if on the first page of links
	page_num = (links_low / 3);
	prev_page_action = "p2_update_links(" + page_num + ")"
	p2_pagination_html = '<a id="p2-pagination_prev" onclick="' + prev_page_action + '"';
	if (links_low == 0) {
		p2_pagination_html += ' style="display:none;"';
	}	
	p2_pagination_html += ' title="Previous links">';
	p2_pagination_html += '<div id="p2-pagination_prev-button"></div';
	p2_pagination_html += '</a>';

	// Generate the "next" button and action. Won't display if there isn't another page of links
	page_num = (links_low / 3) + 2;
	next_page_action = "p2_update_links(" + page_num + ")";
	p2_pagination_html += '<a id="p2-pagination_next" onclick="' + next_page_action + '"';
	var page_max = links_low + 3;
	if (total_links <= page_max) {
		p2_pagination_html += ' style="display:none;"';
	}
	p2_pagination_html += ' title="Next links">';
	p2_pagination_html += '<div id="p2-pagination_next-button"></div';
	p2_pagination_html += '</a>';
	
	// Add the pagination to the Link Assist div
	jQuery("#p2-pagination").empty().html(p2_pagination_html);
	
	// Display the number of links displayed at the bottom of the Link Assist window
	var low = links_low + 1;
	var links_high = links_low + 2;
	var high = links_high;
	if (total_links > 2) {
		high++;
	}
	p2_link_count = 'Displaying ' + low;
	difference = (total_links - low);
	if (total_links < 1 || total_links == low) {
		p2_link_count += ' of ' + total_links + ' links';
	} else if (difference <= 2){
		p2_link_count += '-' + (low + difference) + ' of ' + total_links + ' links';
	} else {
		p2_link_count += '-' + high + ' of ' + total_links + ' links';
	}
	jQuery("#p2-link_count").empty().html(p2_link_count);
	
}

// Generates and pulls the JSON feed, then passes to a new function
function p2_listlinks(feedlink, thetag, links_low) {

	if (links_low == null || links_low < 0) {
		links_low = 0;
	}
	
	// Make sure the feedlink has a "http://" and trailing forward slash
	feedlink = p2_cleanurl(feedlink);
	
	if (thetag == " ") {
		thetag = null;
	}
	
	// Different actions based on whether the function is passed a tag to filter by
	if (thetag != null) {
		jQuery('#p2-filter_tag').val(thetag);
		var tagdashed = p2_cleantag(thetag);
		var json_url = feedlink + tagdashed + '/' + 'json';
	} else {
		jQuery('#p2-filter_tag').val("");
		var json_url = feedlink + 'json';
	}

	// Set the total number of links to display
	var links_high = links_low + 2;
	
	// Start displaying the "loading" graphic
	var rotating_reset = '<img src="/wp-content/plugins/publish2/img/loading-red.gif" />';
	jQuery("#p2-link_assist-reset").html(rotating_reset);
	
	jQuery.ajax({
		type: "GET",
		url: "/wp-content/plugins/publish2/php/p2ajax.php",
		data: {
			url: json_url
		},
		cache: true,
		success: function(data, textStatus) {
			
			// Check to make sure it's a valid JSON feed from Publish2. Else, parse it
			if (data.charAt(2) != 't') {
				data = 'badfeed';
			} else {
				data = JSON.parse(data);
				var total_links = 0;
				var valid_tag = false;
				jQuery.each(data.items, function(i, item) {
					
					// Checks to make sure that the tag being used to filter will actually produce a legitimate feed. Checks tags in the feed to do so
					if (thetag != null && thetag != '' && item.tags != undefined && item.tags != undefined) {
						jQuery.each(item.tags[0], function(i, tag) {
							if (tag.name.toLowerCase() == thetag.toLowerCase()) {
								valid_tag = true;
							}
						});
					} else {
						valid_tag = true;
					}
						
					total_links++;
				});
				if (total_links == 0 || valid_tag == false) {
					data = 'badtag';
				}
			}
			p2_generatelinks(data, links_low, feedlink);
			
		},
		error: function(XMLHttpRequest, textStatus, errowThrown) {
			alert("request failed: " + textStatus);
		},
		dataType: "text"
	});

}

// Generate the links from the JSON object, then print to the screen
function p2_generatelinks(data, links_low, feedlink) {
	
	// Set the total number of links to display
	var links_high = links_low + 2;
	
	// If the URL hasn't generated a valid JSON feed, prompt for a new URL
	if (data == 'badfeed' || data == 'badtag') {

		// Clean out everything in the div
		jQuery("#p2-pagination").empty();
		jQuery("#p2-link_count").empty();
		jQuery("#p2_links_title").empty().html("Link journalism at your fingertips");
		
		link_element = '<div id="p2-link_404">';
		if (data == 'badfeed') {
			link_element += "<p><em>Whoops</em>, that URL doesn't seem to work.</p>";
			link_element += '<input type="text" id="publish2-feedlink_new" name="publish2-feedlink_new" size="18" />';
			link_element += ' <a href="javascript:void(0)" onclick="p2_linksnav(4)" class="button primary">Try again</a>';
		} else if (data == 'badtag') {
			link_element += "<p><em>Erp</em>, that tag doesn't seem to produce any links. Try a new one?</p>";
		}
		link_element += '</div>';
	
	} else {
	
		// Sets the type of feedlink as journalist, newsgroup, network, or topics
		var feedlink_type = '';
		if (feedlink.indexOf('/journalists/') != -1) {
			feedlink_type = 'journalist';
		} else if (feedlink.indexOf('/newsgroups/') != -1) {
			feedlink_type = 'newsgroup';
		} else if (feedlink.indexOf('/network/') != -1) {
			feedlink_type = 'network';
		} else if (feedlink.indexOf('/topics/') != -1) {
			feedlink_type = 'topics';
		}

		// Cleans up the title of the JSON feed so we can use it as the header of Link Assist
		var title = data.title.slice(9);
		title = title.replace(/JSON Feed/, "");
		jQuery("#p2_links_title").empty().html(title);
	
		var link_element = '';
		var total_links = 0;
	
		jQuery.each(data.items, function(i, item) {
			total_links++;
		});

		jQuery.each(data.items,	function(i, item) {
		
			link_element += '<div class="p2-link"';
			if (i < links_low || i > links_high) {
				link_element += ' style="display:none;"';	
			}
			link_num = i + 1;
			link_element += ' id="p2-link_num-' + link_num + '">';
			link_element += '<div class="p2-link_title">' + link_num + '. '+ item.title + '</div>';
		
			link_element += '<div class="p2-link_description">';
			if (feedlink_type == 'newsgroup' || feedlink_type == 'network' || feedlink_type == 'topics') {
			
				var journalistlinks = item.journalist_profile + '/links/';
				var journalistaction = "p2_listlinks('" + journalistlinks + "');return false;";
				link_element += '<a href="' + item.journalist_profile + '" onclick="' + journalistaction + ';">';
				link_element += item.journalist_full_name + '</a>';
				if (item.description != '') {
					link_element += ' says: ' + item.description;
				} else {
					link_element += " saved this link.";
				}
			
			} else {
			
				link_element += item.description;
			
			}
			link_element += '</div>';
		
			// There are some feeds that jQuery won't parse unless you have both statements here. It's majik
			if (item.tags != undefined && item.tags != undefined) {
				link_tags = '<div class="p2-link_tags">Tagged:';
				jQuery.each(item.tags[0], function(i, tag) {
					if (feedlink_type == 'topics') {
						feedlink = 'http://www.publish2.com/topics/';
					}
					thetag = tag.name.replace(/\'/g, '-');
					var tagaction = "p2_listlinks('" + feedlink + "', '" + thetag + "');return false;";
					link_tags += ' <a href="' + tag.link + '" onclick="' + tagaction + '">' + tag.name + '</a>,';
				});
				link_tags = link_tags.replace(/,$/,"");
				link_element += link_tags + '</div>';
			}
		
			// Create and append the buttons to insert a link or open in new window
			link_element += '<div class="p2-link_action">';
			link_element += '<a href="javascript:void(0);" class="button-primary" ';
			var linkaction = "p2_addlink('"+item.link+"');return false;";
			link_element += 'onclick="' + linkaction + '">Add link</a>&nbsp;';
			link_element += '<a href="' + item.link + '" target="_blank" class="button">Open in new window</a>';
			link_element += '</div></div>';

		});

		// Create page buttons, reset the loading image, and display all of the links in the feed
		p2_create_pagination(links_low, total_links);
	
	}
	
	// Stop the loading graphic and then display all of the links
	var static_reset = '<img src="/wp-content/plugins/publish2/img/loading_static-red.gif" />';
	jQuery("#p2-link_assist-reset").html(static_reset);
	jQuery("#publish2-link_assist-links").html(link_element);
	
	// Somewhat hackish method for storing the temporary variables hidden at the bottom of the box
	var p2_temp_settings = '<span id="p2-temp_links_low">' + links_low + '</span><span id="p2-temp_total_links">' + total_links + '</span>';
	jQuery('#p2-temp_settings').empty().html(p2_temp_settings);

}